#include<algorithm>
#include<iostream>
#include<cstdio>
#include<vector>

using namespace std;

const int N = 16+1, M = 10+1, SZ = 1<<20;

int n, m, s;
long long k;
int p[M][N];
vector<pair<int, int> > pre, suf;
int pre_by_mask[SZ], suf_by_mask[SZ];

inline int count_lesser(const vector<pair<int, int> >& v, int x){
    return lower_bound(v.begin(), v.end(), make_pair(x, 0))-v.begin();
}

inline int count_equals(const vector<pair<int, int> >& v, int x){
    return count_lesser(v, x+1) - count_lesser(v, x);
}

inline int count_greater(const vector<pair<int, int> >& v, int x){
    return v.size() - count_lesser(v, x+1);
}

inline void init_pre(int ind=0, int sum=0, int mask=0){
    if(ind == s){
        pre.push_back(make_pair(sum, mask));
        return;
    }
    mask *= n;
    for(int i = 0; i < n; ++i)
        init_pre(ind+1, sum+p[ind][i], mask+i);
}

inline void init_suf(int ind=0, int sum=0, int mask=0){
    if(ind == m-s){
        suf.push_back(make_pair(sum, mask));
        return;
    }
    mask *= n;
    for(int i = 0; i < n; ++i)
        init_suf(ind+1, sum+p[s+ind][i], mask+i);
}

inline long long f(int x){
    long long res = 0;
    for(int i = 0; i < pre.size(); ++i)
        res += count_greater(suf, x-pre[i].first);
    return res;
}

inline string unpack(int mask, int sz){
    string ans(sz, 0);
    for(int i = 0; i < sz; ++i){
        ans[i] = 'a' + (mask%n);
        mask /= n;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}
int main(){
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m >> k;
    s = m/2;
    int l=-1, r=1;
    for(int i = 0; i < m; ++i){
        int mn = 2e9, mx = -1;
        for(int j = 0; j < n; ++j){
            cin >> p[i][j];
            mn = min(mn, p[i][j]);
            mx = max(mx, p[i][j]);
        }
        l += mn;
        r += mx;
    }
    init_pre();
    sort(pre.begin(), pre.end());
    for(int i = 0; i < pre.size(); ++i)
        pre_by_mask[pre[i].second] = pre[i].first;
    init_suf();
    sort(suf.begin(), suf.end());
    for(int i = 0; i < suf.size(); ++i)
        suf_by_mask[suf[i].second] = suf[i].first;
    while(l+1 < r){
        int m = (l+r)/2;
        if(f(m) >= k)
            l = m;
        else
            r = m;
    }
    k -= f(r);
    for(int i = 0; i < pre.size(); ++i){
        int x = r - pre_by_mask[i];
        int cnt = count_equals(suf, x);
        if(k <= cnt)
            for(int j = 0; j < suf.size(); ++j)
                if(suf_by_mask[j] == x){
                    --k;
                    if(k == 0){
                        cout << unpack(i, s) + unpack(j, m-s) << '\n';
                        return 0;
                    }
                }
        k -= cnt;
    }
}
